



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>设计模式之工厂模式VS抽象工厂</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">设计模式之工厂模式VS抽象工厂</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:51:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、工厂模式主要是为创建对象提供过渡接口，以便将创建对象的具体过程屏蔽隔离起来，达到提高灵活性的目的。</strong></p>
<p><strong>工厂模式在《Java与模式》中分为三类：<br />1）简单工厂模式（Simple Factory）：不利于产生系列产品；</p>
<p>2）工厂方法模式（Factory Method）：又称为多形性工厂；</p>
<p>3）抽象工厂模式（Abstract Factory）：又称为工具箱，产生产品族，但不利于产生新的产品；<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;这三种模式从上到下逐步抽象，并且更具一般性。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;GOF在《设计模式》一书中将工厂模式分为两类：工厂方法模式（Factory Method）与抽象工厂模式（Abstract Factory）。将简单工厂模式（Simple Factory）看为工厂方法模式的一种特例，两者归为一类。</strong></p>
<p><strong><strong>二、简单工厂模式</strong></p>
<p>简单工厂模式又称<strong>静态工厂方法模式</strong>。重命名上就可以看出这个模式一定很简单。它存在的目的很简单：定义一个用于创建对象的接口。</strong></p>
<div>在简单工厂模式中,一个工厂类处于对产品类实例化调用的中心位置上,它决定那一个产品类应当被实例化, 如同一个交通警察站在来往的车辆流中,决定放行那一个方向的车辆向那一个方向流动一样。</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;先来看看它的组成：</p>
<p>1) 工厂类角色：这是本模式的核心，含有一定的商业逻辑和判断逻辑。在java中它往往由一个具体类实现。</p>
<p>2) 抽象产品角色：它一般是具体产品继承的父类或者实现的接口。在java中由接口或者抽象类来实现。</p>
<p>3) 具体产品角色：工厂类所创建的对象就是此角色的实例。在java中由一个具体类实现。</p></div>
<div><strong>三、工厂方法模式</strong></p>
<div>工厂方法模式是简单工厂模式的进一步抽象化和推广，工厂方法模式里不再只由一个工厂类决定那一个产品类应当被实例化,这个决定被交给抽象工厂的子类去做。<br />　　来看下它的组成：</p>
<p>1)抽象工厂角色： 这是工厂方法模式的核心，它与应用程序无关。是具体工厂角色必须实现的接口或者必须继承的父类。在java中它由抽象类或者接口来实现。</p>
<p>2)具体工厂角色：它含有和具体业务逻辑有关的代码。由应用程序调用以创建对应的具体产品的对象。</p>
<p>3)抽象产品角色：它是具体产品继承的父类或者是实现的接口。在java中一般有抽象类或者接口来实现。</p>
<p>4)具体产品角色：具体工厂角色所创建的对象就是此角色的实例。在java中由具体的类来实现。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;工厂方法模式使用继承自抽象工厂角色的多个子类来代替简单工厂模式中的&ldquo;上帝类&rdquo;。正如上面所说，这样便分担了对象承受的压力；而且这样使得结构变得灵活 起来&mdash;&mdash;当有新的产品（即暴发户的汽车）产生时，只要按照抽象产品角色、抽象工厂角色提供的合同来生成，那么就可以被客户使用，而不必去修改任何已有的代 码。可以看出工厂角色的结构也是符合开闭原则的！</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1004015/201611/1004015-20161101143027252-645126180.png" /></div>
<div>代码：</div>
<div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//抽象产品角色<br />
public class LeiFeng {<br />
    public void sweep(){<br />
        System.out.println("扫地");<br />
    }<br />
    public void wash(){<br />
        System.out.println("洗衣服");<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//具体产品角色<br />
public class Student extends LeiFeng{

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//具体产品角色<br />
public class Volunter extends LeiFeng{

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//抽象工厂<br />
public interface IFactory {<br />
    public LeiFeng getLeiFeng();<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//具体工厂<br />
public class StudentFactory implements IFactory{

    @Override<br />
    public LeiFeng getLeiFeng() {<br />
        return new Student();<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;<br />
//具体工厂<br />
public class VolunterFactory implements IFactory{

    @Override<br />
    public LeiFeng getLeiFeng() {

        return new Volunter();<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.b;

//测试类<br />
public class Test {

    public static void main(String[] args) {<br />
        IFactory factory=new StudentFactory();<br />
        //IFactory factory=new VolunterFactory();<br />
        LeiFeng stu=factory.getLeiFeng();<br />
        stu.wash();<br />
        stu.sweep();

    }

}</pre>
</div>
<p>工厂方法定义：</p>
<p>定义一个用于创建对象的接口，让子类决定实例化哪一个类。工厂方法使一个类的实例化延迟到了子类</p>
<p>在简单工厂中，工厂类与分支耦合，所以我们就对工厂类下手，把工厂类抽象出一个接口，</p>
<p>这个接口只有一个方法，就是创建抽象产品的工厂方法，然后所有要生产具体的工厂，都实现这个接口，这样简单工厂的工厂类就变成了一个工厂抽象接口和多个具体生产对象的工厂，要增加功能，就不需要更改原来的工厂类，之需要增加此功能的类和相应的工厂类就可以了</p>
</div>
<div><strong>四、简单工厂和工厂方法模式的比较</strong></p>
<p>工厂方法模式和简单工厂模式在定义上的不同是很明显的。工厂方法模式的核心是一个抽象工厂类,而不像简单工厂模式, 把核心放在一个实类上。工厂方法模式可以允许很多实的工厂类从抽象工厂类继承下来, 从而可以在实际上成为多个简单工厂模式的综合,从而推广了简单工厂模式。&nbsp;<br />反过来讲,简单工厂模式是由工厂方法模式退化而来。设想如果我们非常确定一个系统只需要一个实的工厂类, 那么就不妨把抽象工厂类合并到实的工厂类中去。而这样一来,我们就退化到简单工厂模式了。</div>
<div><strong>五、抽象工厂模式</strong></div>
<div>
<p>定义：</p>
<p>提供一个创建一系列相关或相互依赖对象的接口，而无须指定他们具体的类</p>
<p><strong>抽象工厂模式：</strong></p>
<p>多个抽象产品类，每个抽象产品类可以派生出多个具体产品类。 &nbsp;&nbsp;<br />一个抽象工厂类，可以派生出多个具体工厂类。 &nbsp;&nbsp;<br />每个具体工厂类可以创建多个具体产品类的实例。</p>
<p><strong>抽象工厂模式与工厂方法模式的区别</strong></p>
<p>抽象工厂模式是工厂方法模式的升级版本，他用来创建一组相关或者相互依赖的对象。他与工厂方法模式的区别就在于，工厂方法模式针对的是一个产品等级结构；而抽象工厂模式则是针对的多个产品等级结构。在编程中，通常一个产品结构，表现为一个接口或者抽象类，也就是说，工厂方法模式提供的所有产品都是衍生自同一个接口或抽象类，而抽象工厂模式所提供的产品则是衍生自不同的接口或抽象类。</p>
<p>在抽象工厂模式中，有一个<strong>产品族</strong>的概念：所谓的产品族，是指<strong>位于不同产品等级结构中功能相关联的产品组成的家族</strong>。抽象工厂模式所提供的一系列产品就组成一个产品族；而工厂方法提供的一系列产品称为一个等级结构。我们依然拿生产汽车的例子来说明他们之间的区别。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1004015/201611/1004015-20161101144534096-1653923022.png" /></p>
<p>在上面的类图中，User和Student是两个抽象产品，之所以为抽象，是因为他们都有可能有两种不同的实现，而SqlUser、AccessUser和SqlStudent、AccessStudent</p>
<p>就是对这两个抽象产品的具体分类</p>
<p>IFactory是一个抽象工厂接口，他里面应该包含所有产品创建的抽象方法，SqlFactory和AccessFatory就是具体工厂；</p>
<p>代码：</p>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class User {<br />
    private int id;<br />
    private String name;<br />
    public int getId() {<br />
        return id;<br />
    }<br />
    public void setId(int id) {<br />
        this.id = id;<br />
    }<br />
    public String getName() {<br />
        return name;<br />
    }<br />
    public void setName(String name) {<br />
        this.name = name;<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class Student {<br />
    private int id;<br />
    private String name;<br />
    public int getId() {<br />
        return id;<br />
    }<br />
    public void setId(int id) {<br />
        this.id = id;<br />
    }<br />
    public String getName() {<br />
        return name;<br />
    }<br />
    public void setName(String name) {<br />
        this.name = name;<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;<br />
/**<br />
 * IUser接口，用于客户端访问，解除与具体数据库访问的耦合<br />
 * @author 川哥哥<br />
 *<br />
 */<br />
public interface IUser {<br />
    public void insert(User user);<br />
    public User getUser(int id);<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public interface IStudent {<br />
    public void insert(Student stu);<br />
    public Student getUser(int id);<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class SqlUser implements IUser{

    @Override<br />
    public void insert(User user) {<br />
        System.out.println("sql中给user表添加一条记录");<br />
    }

    @Override<br />
    public User getUser(int id) {<br />
        System.out.println("在sql中根据id得到一条记录");<br />
        return null;<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class AccessUser implements IUser{

    @Override<br />
    public void insert(User user) {<br />
        System.out.println("Access中给user表添加一条记录");

    }

    @Override<br />
    public User getUser(int id) {<br />
        System.out.println("在Access中根据id得到一条记录");<br />
        return null;<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class SqlStudent implements IStudent{

    @Override<br />
    public void insert(Student stu) {<br />
        System.out.println("在sql中给student表添加一条记录");

    }

    @Override<br />
    public Student getUser(int id) {<br />
        System.out.println("在sql中，根据Id得到一条记录");<br />
        return null;<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class AccessStudent implements IStudent{<br />
    @Override<br />
    public void insert(Student stu) {<br />
        System.out.println("在Access中给student表添加一条记录");

    }

    @Override<br />
    public Student getUser(int id) {<br />
        System.out.println("在Access中，根据Id得到一条记录");<br />
        return null;<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;<br />
/**<br />
 * 定义一个接口，创建访问user表对象的抽象工厂类<br />
 * @author 川哥哥<br />
 *<br />
 */<br />
public interface IFactory {<br />
    public IUser creIUser();<br />
    public IStudent greateStudent();<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;<br />
/**<br />
 * 实现Ifactory接口，实例化SqlUser<br />
 * @author 川哥哥<br />
 *<br />
 */<br />
public class<br />
SqlFactory implements IFactory{

    @Override<br />
    public IUser creIUser() {

        return new SqlUser();<br />
    }

    @Override<br />
    public IStudent greateStudent() {<br />
        // TODO Auto-generated method stub<br />
        return new SqlStudent();<br />
    }

}</pre>
</div>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class AccessFactory implements IFactory{

    @Override<br />
    public IUser creIUser() {

        return new AccessUser();<br />
    }

    @Override<br />
    public IStudent greateStudent() {<br />
        // TODO Auto-generated method stub<br />
        return new AccessStudent();<br />
    }

}</pre>
</div>
<p>测试类</p>
<div>
<pre class="prettyprint linenums">package cn.happy.c;

public class Test {

    public static void main(String[] args) {

        User user=new User();<br />
        Student stu=new Student();<br />
        IFactory factory=new SqlFactory();<br />
        //IFactory factory=new AccessFactory();<br />
        IUser iUser=factory.creIUser();<br />
        IStudent is=factory.greateStudent();<br />
        iUser.insert(user);<br />
        iUser.getUser(1);<br />
        is.insert(stu);<br />
        is.getUser(1);<br />
 }<br />
}</pre>
</div>
<p>运行结果：</p>
<p>sql中给user表添加一条记录<br />在sql中根据id得到一条记录<br />在sql中给student表添加一条记录<br />在sql中，根据Id得到一条记录</p>
<p><strong>抽象工厂模式的优点</strong></p>
<p>抽象工厂模式除了具有工厂方法模式的优点外，最主要的优点就是可以在类的内部对产品族进行约束。所谓的产品族，一般或多或少的都存在一定的关联，抽象工厂模式就可以在类内部对产品族的关联关系进行定义和描述，而不必专门引入一个新的类来进行管理。</p>
<p><strong>抽象工厂模式的缺点</strong></p>
<p>产品族的扩展将是一件十分费力的事情，假如产品族中需要增加一个新的产品，则几乎所有的工厂类都需要进行修改。所以使用抽象工厂模式时，对产品等级结构的划分是非常重要的。</p>
<p><strong>适用场景</strong></p>
<p>当需要创建的对象是一系列相互关联或相互依赖的产品族时，便可以使用抽象工厂模式。说的更明白一点，就是一个继承体系中，如果存在着多个等级结构（即存在着多个抽象类），并且分属各个等级结构中的实现类之间存在着一定的关联或者约束，就可以使用抽象工厂模式。假如各个等级结构中的实现类之间不存在关联或约束，则使用多个独立的工厂来对产品进行创建，则更合适一点。</p>
<p><strong>总结</strong></p>
<p>无论是简单工厂模式，工厂方法模式，还是抽象工厂模式，他们都属于工厂模式，在形式和特点上也是极为相似的，他们的最终目的都是为了解耦。在使用时，我们不必去在意这个模式到底工厂方法模式还是抽象工厂模式，因为他们之间的演变常常是令人琢磨不透的。经常你会发现，明明使用的工厂方法模式，当新需求来临，稍加修改，加入了一个新方法后，由于类中的产品构成了不同等级结构中的产品族，它就变成抽象工厂模式了；而对于抽象工厂模式，当减少一个方法使的提供的产品不再构成产品族之后，它就演变成了工厂方法模式。</p>
<p>所以，在使用工厂模式时，只需要关心降低耦合度的目的是否达到了。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8exeeq1.html">ABP框架 - 多租户</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pje5z9.html">Keepalived的全局配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqljwj09.html">CSS 中Font Awesome 图标（附码表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxlddvq.html">jquery&comma;php之间的ajax关系以及json</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvk75x9.html">在sql server中利用with as实现递归功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r632d9.html">sphinx教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn4vrj8.html">Zookeeper-Zookeeper client</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evv3z9.html">Routine Problem（数学）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxky5q.html">WampServer搭建php环境可能遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3yke8.html">Python学习教程&lpar;learning Python&rpar;--2&period;3&period;4Python函数返回值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vnl69.html">3142&colon;&lbrack;HNOI2013&rsqb;数列 - BZOJ</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmkpdk9.html">【转】前端图片该保存为什么格式？png or jpg？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjedmk9.html">codevs 版刷计划&lpar;1000-1099&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oko4r59.html">&lbrack;OJ&rsqb; Data Stream Median &lpar;Hard&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1x23x9.html">linux和MAC下静态库&period;a文件合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1nyod9.html">&lbrack;BZOJ 3238&rsqb; &lbrack;AHOI 2013&rsqb; 差异 【后缀数组 &plus; 单调栈】</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orr149.html">hbase region 分配方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj13dk9.html">mina 实例（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j25zo8.html">&lbrack;进程管理&rsqb; Linux中Load average的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p2x638.html">C&plus;&plus;11的value category（值类别）以及move semantics（移动语义）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/6o8k469j.html">启动了VSAN服务的主机不在vCenter集群中</a>
			</li>
						<li><a href="https://www.batexi.com/a/yg8elmq1.html">java&colon; web应用中不经意的内存泄露</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kpoj9j.html">使用etree&period;HTML的编码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1kzqx.html">【微框架】Maven &plus;SpringBoot  集成 阿里大鱼 短信接口详解与Demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mer2qk.html">23种设计模式--观察者模式-Observer Pattern</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdpvzqd.html">使用Oracle官方巡检工具ORAchk巡检数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q257oq7.html">获取微软原版&OpenCurlyDoubleQuote;Windows 10 推送器（GWX）&rdquo; 卸载工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jmmw95.html">springMVC学习笔记--知识点总结1</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8odglqz.html">iptables</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwo2y97.html">PHP设计模式（八）桥接模式（Bridge For PHP）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
